/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   burning_ship.c                                     :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/24 19:36:06 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/24 19:36:26 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

int		complex_ship(t_complex new, t_complex com_const, t_frac_data *data)
{
	int			i;
	t_complex	old;

	i = 0;
	while (i < data->max_itr)
	{
		old = new;
		new.rl = fabsl(old.rl * old.rl - old.im * old.im + com_const.rl);
		new.im = fabsl(2 * old.rl * old.im + com_const.im);
		if ((new.rl * new.rl + new.im * new.im) > 4)
			break ;
		i++;
	}
	return (i);
}

t_color	ship(t_frac_data *sh, int x, int y)
{
	t_complex	new;
	int			i;

	new.rl = 1.5 * (x - WIDTH / 2) / (0.5 * sh->mov.z * WIDTH) +
			sh->mov.x - 0.5;
	new.im = (y - HEIGHT / 2) / (0.5 * sh->mov.z * HEIGHT) +
			sh->mov.y - 0.5;
	i = complex_ship(sh->com_const, new, sh);
	return (gradient((float)i / sh->max_itr, sh->grd));
}
