/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   parse_input.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/24 19:32:10 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/24 19:32:11 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include <fractol.h>

int		check_argument(char *arg)
{
	if (!ft_strcmp(arg, "julia"))
		return (0);
	if (!ft_strcmp(arg, "mandelbrot"))
		return (1);
	if (!ft_strcmp(arg, "ship"))
		return (2);
	return (-1);
}

void	error(void)
{
	print_help();
	quit(0);
}

void	parse_input(int ac, char **av)
{
	int	i;
	int	frac_type;
	int	pid;

	if (ac < 2)
		error();
	i = 0;
	while (i < ac - 1)
		if (((frac_type = check_argument(av[i + 1])) != -1))
		{
			pid = fork();
			if (pid > 0)
			{
				fractal_fork(frac_type);
				break ;
			}
			if (pid == 0)
				i++;
		}
		else
			error();
}
