/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   threads_routine.c                                  :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/24 19:35:25 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/24 19:35:26 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

t_thread_data		*thread_data_init(t_fractol *fr, int i)
{
	t_thread_data	*data;
	int				img_strip;

	img_strip = (int)ceil(HEIGHT / NUM_THREADS) + 1;
	data = malloc(sizeof(t_thread_data));
	data->y_start = img_strip * i;
	data->y_end = data->y_start + img_strip;
	data->fr = *fr;
	data->fractal_func = fr->fr_funcs[fr->frac->frac_type];
	return (data);
}

void				parallel_fractal(t_fractol *fr)
{
	pthread_t		threads[NUM_THREADS];
	pthread_attr_t	attr;
	t_thread_data	*data;
	int				i;

	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
	i = 0;
	while (i < NUM_THREADS)
	{
		data = thread_data_init(fr, i);
		pthread_create(&threads[i], &attr, fractal_routine, (void *)data);
		i++;
	}
	pthread_attr_destroy(&attr);
	i = 0;
	while (i < NUM_THREADS)
		pthread_join(threads[i++], NULL);
}
